inlets = 1
outlets = 1

var matrix
var rows
var cols

function init() {
	matrix = new Array()
	rows = 0
	cols = 0
}

function list() {
	var args = arrayfromargs(arguments)
	var colIdx = args.shift() 
	var rowIdx = args.shift()
	var value = args.join(' ')

	var row = matrix[rowIdx]
	if(!row) row = matrix[rowIdx] = new Array()
	row[colIdx] = value
	
	var rowCount = rowIdx+1
	var colCount = colIdx+1
	if(rowCount > rows) rows = rowCount
	if(colCount > cols) cols = colCount
}

function write(filepath) {
	var file = new File(filepath, 'write', '')
	for(var rowIdx=0; rowIdx<rows; rowIdx++) {
		var row = matrix[rowIdx]
		var line = ''
		for(var colIdx=0; colIdx<cols; colIdx++) {
			if(colIdx > 0) line += ','
			line += escapeCsvValue(row[colIdx])
		}
		file.writeline(line)
	}
	file.eof = file.position
	file.close()
}

escapeCsvValue.private = 1
function escapeCsvValue(value) {
	if(!value) return ''
	return '"' + value.replace('"', '""', 'g') + '"'
}